2002-11-30 Alexandre Duret-Lutz <adl@gnu.org>
+ * automake.in (scan_texinfo_file): Honor only the first @setfilename.
+ * tests/texinfo17.test: New file.
+ * tests/Makefile.am (TESTS): Add texinfo17.test.
+ Reported by Karl Berry.
+
For PR automake/357:
* automake.in (require_file_internal): Don't complain a file is "not
found" when it is a target. Make sure "not found" files are otherwise
{
if (/^\@setfilename +(\S+)/)
{
+ # Honor only the first @setfilename. (It's possible to have
+ # more occurences later if the manual shows examples of how
+ # to use @setfilename...)
+ next if $outfile;
+
$outfile = $1;
if ($outfile =~ /\.(.+)$/ && $1 ne 'info')
{
--- /dev/null
+#! /bin/sh
+# Copyright (C) 2002 Free Software Foundation, Inc.
+#
+# This file is part of GNU Automake.
+#
+# GNU Automake is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# GNU Automake is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with autoconf; see the file COPYING. If not, write to
+# the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
+
+# Make sure Automake uses the _first_ @setfilname it sees.
+# Report from Karl Berry.
+
+. ./defs || exit 1
+
+set -e
+
+cat > Makefile.am << 'END'
+info_TEXINFOS = texinfo.texi
+END
+
+cat > texinfo.texi << 'END'
+@setfilename texinfo
+...
+@verbatim
+@setfilename example.info
+@end verbatim
+...
+END
+
+$ACLOCAL
+$AUTOMAKE --add-missing
+
+grep 'example' Makefile.in && exit 1
+grep 'texinfo:' Makefile.in